=== doc/sphinx/requirements.txt ===
canonical-sphinx[full]
packaging
sphinxcontrib-svg2pdfconverter[CairoSVG]
sphinx-last-updated-by-git
sphinx-sitemap
breathe
exhale
pillow
sphinxcontrib-mermaid
