=== debian/changelog ===
mir (2.25.2-1) experimental; urgency=medium

  * New upstream release.
  * debian/:
    + SOVERSION major bump.
  * debian/patches/:
    + Rebase patches 1003, 2003 and 2005.
    + Add 1005_typo-fixes.patch. Fix typo in TEST names.
    + Drop 1004_fix-autopkgtest.patch. Applied upstream.
    + Forward upstream: 1003_cross.patch and 1005_typo-fixes.patch.
  * debian/control:
    + Apply wrap-and-sort -t -n -a.
    + Drop Pre-Depends: fields.
    + Drop Priority: optional.
    + Update B-Ds for v2.25.2.
    + Bump Standards-Version: to 4.7.3.
    + Adjust dev:pkgs to new version.
    + Drop libboost-system-dev. (Closes: #1127238).
  * debian/rules:
    + Adopt from upstream's DEB packaging Git.
    + Fix setting of XDG_RUNTIME_DIR in ptest environment.
    + Fail build on test failure.
    + Set DPKG_EXPORT_BUILDFLAGS to 1.
  * debian/*.install:
    + Adjust (and wrap-and-sort) to new version.
  * debian/{control,rules}:
    + Drop pkg-kde-tools. Stop maintaining .symbols files with pkgkde-symbols-
      helper.
  * debian/source/lintian-overrides:
    + Fix line number in file.
    + Drop reference to file not in upstream source tree anymore.
  * debian/tests/control:
    + Apply wrap-and-sort.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
    + Update attributions for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 28 Feb 2026 23:49:27 +0100
