=== debian/control ===
Source: mir
Section: x11
Maintainer: Debian Mir Team <team+mir@tracker.debian.org>
Uploaders: Simon Quigley <tsimonq2@debian.org>,
           Christopher James Halse Rogers <raof@ubuntu.com>,
           Mike Gabriel <sunweaver@debian.org>,
           Debian UBports Team <team+ubports@tracker.debian.org>,
           Marius Gripsgard <mariogrip@debian.org>,
Build-Depends: cmake,
               dbus,
               debhelper-compat (= 13),
               doxygen,
               dpkg-dev (>= 1.22.5),
               eglexternalplatform-dev [amd64 i386],
               google-mock (>= 1.6.0+svn437) <!noinsttest>,
               graphviz,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libclang-dev,
               libdisplay-info-dev,
               libdrm-dev,
               libegl-dev,
               libepoxy-dev,
               libevdev-dev,
               libfreetype-dev,
               libgbm-dev,
               libgles-dev,
               libglib2.0-dev,
               libglm-dev,
               libgoogle-glog-dev,
               libgtest-dev <!noinsttest>,
               libinput-dev (>= 0.21),
               liblttng-ust-dev,
               libmirwayland-bin <cross>,
               libnvidia-egl-wayland-dev [amd64 i386],
               libpixman-1-dev,
               libudev-dev,
               libumockdev-dev (>= 0.6) <!noinsttest>,
               libwayland-dev,
               libx11-xcb-dev,
               libxcb-composite0-dev,
               libxcb-randr0-dev,
               libxcb-render0-dev,
               libxcb-res0-dev,
               libxcb-xfixes0-dev,
               libxcursor-dev,
               libxkbcommon-dev (>= 0.5),
               libxkbcommon-x11-dev,
               libxml++2.6-dev,
               libyaml-cpp-dev,
               linux-libc-dev,
               nettle-dev,
               pkgconf,
               python3-dbusmock <!noinsttest>,
               python3-pil:native,
               rdfind,
               symlinks,
               systemtap-sdt-dev,
               umockdev (>= 0.8.7) <!noinsttest>,
               uuid-dev,
# only enable valgrind once it's been tested to work on each architecture:
               valgrind-if-available <!noinsttest>,
               wlcs (>= 1.6.0) <!noinsttest>,
               xsltproc,
               xwayland,
Standards-Version: 4.7.3
Rules-Requires-Root: no
Homepage: https://mir-server.io/
Vcs-Browser: https://salsa.debian.org/mir-server-team/mir
Vcs-Git: https://salsa.debian.org/mir-server-team/mir.git

#TODO: Packaging infrastructure for better dependency generation,
#      ala pkg-xorg's xviddriver:Provides and ABI detection.
Package: libmirserver66
Replaces: libmirserver58,
          libmirserver58t64,
          libmirserver62,
          libmirserver63,
Breaks: libmirserver58 (<< ${source:Version}),
        libmirserver58t64 (<< ${source:Version}),
        libmirserver62 (<< ${source:Version}),
        libmirserver63 (<< ${source:Version}),
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - server library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared library needed by server applications for Mir.

Package: libmirplatform34
Replaces: libmirplatform26,
          libmirplatform26t64,
          libmirplatform30,
Breaks: libmirplatform26 (<< ${source:Version}),
        libmirplatform26t64 (<< ${source:Version}),
        libmirplatform30 (<< ${source:Version}),
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - platform library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server to interact with
 the underlying hardware platform.

Package: libmircore-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libmircore2t64 (= ${binary:Version}),
         ${misc:Depends},
Description: Mir Display Server - core library - development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains core header files required for server and/or client development.

Package: libmircommon-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libmircommon11 (= ${binary:Version}),
         libmircore-dev (= ${binary:Version}),
         libxkbcommon-dev,
         ${misc:Depends},
Breaks: mircommon-dev (<< 0.6),
Replaces: mircommon-dev (<< 0.6),
Description: Mir Display Server - common library - development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains common header files required for server and/or client development.

Package: libmircommon-internal-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libmircommon-dev (= ${binary:Version}),
         libxkbcommon-dev,
         ${misc:Depends},
Description: Mir Display Server - internal common development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 This package contains common internal headers with no stability
 guarantee, for servers that wish to use functionality for which no
 public API exists yet.

Package: libmirplatform-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libboost-program-options-dev,
         libgbm-dev,
         libmircommon-dev (= ${binary:Version}),
         libmirplatform34 (= ${binary:Version}),
         ${misc:Depends},
Breaks: libmirplatform (<< 0.6),
        libmirrenderer-dev (<< 2.24),
        mir-renderer-gl-dev (<< 2.24),
Replaces: libmirplatform (<< 0.6),
          libmirrenderer-dev (<< 2.24),
          mir-renderer-gl-dev (<< 2.24),
Provides: libmirrenderer-dev,
          mir-renderer-gl-dev,
Description: Mir Display Server - platform library - development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files required for hardware/driver support development.

Package: libmirserver-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libglm-dev,
         libmircommon-dev (= ${binary:Version}),
         libmirplatform-dev (= ${binary:Version}),
         libmirserver66 (= ${binary:Version}),
         uuid-dev,
         ${misc:Depends},
Description: Mir Display Server - server library - development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files required to build Mir servers.

Package: libmirserver-internal-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libglm-dev,
      libmirserver66 (= ${binary:Version}),
      libmirplatform-dev (= ${binary:Version}),
      libmircommon-dev (= ${binary:Version}),
      libmircore-dev (= ${binary:Version}),
      libmirserver-dev (= ${binary:Version}),
      uuid-dev,
      ${misc:Depends},
Description: Mir Display Server - internal server development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 This package contains internal server headers with no stability
 guarantee, for servers that wish to use functionality for which no
 public API exists yet.

Package: mirtest-dev
Build-Profiles: <!noinsttest>
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libmircommon-dev (= ${binary:Version}),
         libmirplatform-dev (= ${binary:Version}),
         libmirserver-dev (= ${binary:Version}),
         mir-platform-graphics-stub23,
         mir-platform-input-stub10,
         ${misc:Depends},
Description: Mir Display Server - test development headers and library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files and static library for testing of server and/or client
 development.

Package: mirtest-internal-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: mirtest-dev,
         libmirserver-dev (= ${binary:Version}),
         ${misc:Depends},
Breaks: mirtest-dev (<< 2.25.2-1~),
Replaces: mirtest-dev (<< 2.25.2-1~),
Description: Mir Display Server - internal test development headers and library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains internal header files and static library for testing of server
 and/or client development.

Package: mir-demos
Architecture: linux-any
Breaks: miral-examples,
Replaces: miral-examples,
Provides: miral-examples (=1.5),
Depends: inotify-tools,
         python3:any,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: dmz-cursor-theme,
            fonts-liberation,
            qtwayland5,
            xwayland,
Description: Mir Display Server - demonstration programs
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains demo applications that use the Mir display server

Package: mir-test-tools
Build-Profiles: <!noinsttest>
Architecture: linux-any
Depends: dmz-cursor-theme,
         glmark2-es2,
         glmark2-es2-wayland,
         mesa-utils-extra,
         xwayland,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - stress tests and other test tools
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains tools for smoke and performance testing the Mir display server

Package: mir-wlcs-integration
Architecture: linux-any
Build-Profiles: <!noinsttest>
Breaks: mir-test-tools (<< 2.0.0.0+dev148~),
Replaces: mir-test-tools (<< 2.0.0.0+dev148~),
Depends: ${misc:Depends},
         ${shlibs:Depends},
         mir-platform-graphics-stub23,
         mir-platform-input-stub10,
Description: Mir Display Server - wlcs integration
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains libraries for integration with the wlcs test suite

Package: libmircore2t64
Provides: ${t64:Provides},
Replaces: libmircore2,
Breaks: libmircore2 (<< ${source:Version}),
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - core library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the 'core' shared library required for the Mir server and client.

Package: libmircommon11
Replaces: libmircommon9,
          libmircommon9t64,
Breaks: libmircommon9 (<< ${source:Version}),
        libmircommon9t64 (<< ${source:Version}),
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - common library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the 'common' shared library required for the Mir server and client.

# Longer-term these drivers should move out-of-tree
Package: mir-platform-graphics-x23
Section: libs
Architecture: linux-any
Multi-Arch: same
Replaces: mir-platform-graphics-x20,
          mir-platform-graphics-x22,
