=== debian/tests/control ===
Tests: wlcs,
Restrictions: allow-stderr,
              skippable,
Depends: build-essential,
         cmake,
         dpkg,
         mir-wlcs-integration,
         pkg-config,
         wlcs,
